# ThunderSVM How To
This page is for instructions of contributing to ThunderSVM. ThunderSVM has been used by many users, and everyone can contribute to ThunderSVM to make it better.

## Install ThunderSVM
To use ThunderSVM, we need to install the following software:

* [CUDA](https://developer.nvidia.com/cuda-downloads)
* cmake

After installing the dependencies, you can start compiling ThunderSVM.

* Clone ThunderSVM repository
```bash
git clone git@github.com:zeyiwen/thundersvm.git --recursive
```
* Build the executable
```bash
cd thundersvm
mkdir build
cd build
cmake ..
make -j
```
Then the executable file under ```build/bin/```. You can now use ThunderSVM, and the options of executing ThunderSVM are available [here](parameters.md).

Please refer to [Getting Started](get-started.md) for some examples of training SVMs using ThunderSVM.

## Improve Documentations
Most of the documents can be viewed on GitHub, although the documents look much better in Read The Doc. The HTML files of our documents are generated by [Sphinx](http://www.sphinx-doc.org/en/stable/), and the source files of the documents are written using [Markdown](http://commonmark.org/). In the following, we describe how to setup the Sphinx environment for ThunderSVM.

* Install sphinx
```bash
pip install sphinx
```

* Install Makedown Parser
```bash
pip install recommonmark
```
Note that ```recommonmark``` has a bug when working with Sphinx in some platforms, so you may need to hack into transform.py to fix the problem by yourself. You can find the instruction of hacking in [this link](https://github.com/sphinx-doc/sphinx/issues/3800).

* Install Sphinx theme
```bash
pip install sphinx_rtd_theme
```

* Generate HTML

   Go to the "docs" directory of ThunderSVM and run:
```bash
make html
```

At this point, make sure you have generated the documents of ThunderSVM. You can build the documents in your machine to see the outcome.

## Contribute to ThunderSVM
You need to fetch the latest version of ThunderSVM before submitting a pull request.
```bash
git remote add upstream https://github.com/zeyiwen/thundersvm
git fetch upstream
git rebase upstream/master
```
Since ThunderSVM runs on GPUs, please test your code using ```make -j runtest``` on your local machine. You can also add more test cases in the test module of ThunderSVM.